

# Product REST endpoint pages


Represents the collection of product REST endpoint pages for a portal product.

## URI


`/v2/portalproducts/portalProductId/productrestendpointpages`

## HTTP methods


### GET


**Operation ID:** `ListProductRestEndpointPages`

Lists the product REST endpoint pages of a portal product.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| portalProductId | String | True | The portal product identifier. | 


**Query parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| nextToken | String | False | The next page of elements from this collection. Not valid for the last element of the collection. | 
| maxResults | String | False | The maximum number of elements to be returned for this resource. | 
| resourceOwnerAccountId | String | False | The account ID of the resource owner of the portal product. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | ListProductRestEndpointPagesResponseContent | Success | 
| 400 | BadRequestExceptionResponseContent | One of the parameters in the request is invalid. | 
| 403 | AccessDeniedExceptionResponseContent | 403 response | 
| 404 | NotFoundExceptionResponseContent | The resource specified in the request was not found. | 
| 429 | LimitExceededExceptionResponseContent | The client is sending more than the allowed number of requests per unit of time. | 

### POST


**Operation ID:** `CreateProductRestEndpointPage`

Creates a product REST endpoint page for a portal product.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| portalProductId | String | True | The portal product identifier. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 201 | CreateProductRestEndpointPageResponseContent | The request has succeeded and has resulted in the creation of a resource. | 
| 400 | BadRequestExceptionResponseContent | One of the parameters in the request is invalid. | 
| 403 | AccessDeniedExceptionResponseContent | 403 response | 
| 404 | NotFoundExceptionResponseContent | The resource specified in the request was not found. | 
| 429 | LimitExceededExceptionResponseContent | The client is sending more than the allowed number of requests per unit of time. | 

## Schemas


### Request bodies


#### POST schema
POST

```
{
  "displayContent": {
    "none": {
    },
    "overrides": {
      "endpoint": "string",
      "operationName": "string",
      "body": "string"
    }
  },
  "tryItState": enum,
  "restEndpointIdentifier": {
    "identifierParts": {
      "path": "string",
      "stage": "string",
      "method": "string",
      "restApiId": "string"
    }
  }
}
```

### Response bodies


#### ListProductRestEndpointPagesResponseContent schema
ListProductRestEndpointPagesResponseContent

```
{
  "nextToken": "string",
  "items": [
    {
      "endpoint": "string",
      "tryItState": enum,
      "statusException": {
        "exception": "string",
        "message": "string"
      },
      "productRestEndpointPageId": "string",
      "operationName": "string",
      "lastModified": "string",
      "restEndpointIdentifier": {
        "identifierParts": {
          "path": "string",
          "stage": "string",
          "method": "string",
          "restApiId": "string"
        }
      },
      "productRestEndpointPageArn": "string",
      "status": enum
    }
  ]
}
```

#### CreateProductRestEndpointPageResponseContent schema
CreateProductRestEndpointPageResponseContent

```
{
  "displayContent": {
    "endpoint": "string",
    "operationName": "string",
    "body": "string"
  },
  "tryItState": enum,
  "statusException": {
    "exception": "string",
    "message": "string"
  },
  "productRestEndpointPageId": "string",
  "lastModified": "string",
  "restEndpointIdentifier": {
    "identifierParts": {
      "path": "string",
      "stage": "string",
      "method": "string",
      "restApiId": "string"
    }
  },
  "productRestEndpointPageArn": "string",
  "status": enum
}
```

#### BadRequestExceptionResponseContent schema
BadRequestExceptionResponseContent

```
{
  "message": "string"
}
```

#### AccessDeniedExceptionResponseContent schema
AccessDeniedExceptionResponseContent

```
{
  "message": "string"
}
```

#### NotFoundExceptionResponseContent schema
NotFoundExceptionResponseContent

```
{
  "message": "string",
  "resourceType": "string"
}
```

#### LimitExceededExceptionResponseContent schema
LimitExceededExceptionResponseContent

```
{
  "message": "string",
  "limitType": "string"
}
```

## Properties


### AccessDeniedExceptionResponseContent


The error message.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| message | string | False | The message. | 

### BadRequestExceptionResponseContent


The response content for bad request exception.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| message | string | False | The message of the bad request exception response content. | 

### CreateProductRestEndpointPageRequestContent


Creates a product REST endpoint page.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| displayContent | [EndpointDisplayContent](#portalproducts-portalproductid-productrestendpointpages-model-endpointdisplaycontent) | False | The content of the product REST endpoint page. | 
| restEndpointIdentifier | [RestEndpointIdentifier](#portalproducts-portalproductid-productrestendpointpages-model-restendpointidentifier) | True | The REST endpoint identifier. | 
| tryItState | [TryItState](#portalproducts-portalproductid-productrestendpointpages-model-tryitstate) | False | The try it state of the product REST endpoint page. | 

### CreateProductRestEndpointPageResponseContent


Creates a product REST endpoint page.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| displayContent | [EndpointDisplayContentResponse](#portalproducts-portalproductid-productrestendpointpages-model-endpointdisplaycontentresponse) | True | The display content. | 
| lastModified | stringFormat: date-time | True | The timestamp when the product REST endpoint page was last modified. | 
| productRestEndpointPageArn | stringMinLength: 20MaxLength: 2048 | True | The ARN of the product REST endpoint page. | 
| productRestEndpointPageId | stringPattern: `^[a-z0-9]+$`MinLength: 10MaxLength: 30 | True | The product REST endpoint page identifier. | 
| restEndpointIdentifier | [RestEndpointIdentifier](#portalproducts-portalproductid-productrestendpointpages-model-restendpointidentifier) | True | The REST endpoint identifier. | 
| status | [Status](#portalproducts-portalproductid-productrestendpointpages-model-status) | True | The status. | 
| statusException | [StatusException](#portalproducts-portalproductid-productrestendpointpages-model-statusexception) | False | The status exception information. | 
| tryItState | [TryItState](#portalproducts-portalproductid-productrestendpointpages-model-tryitstate) | True | The try it state. | 

### DisplayContentOverrides


Contains any values that override the default configuration generated from API Gateway.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| body | stringMinLength: 1MaxLength: 32768 | False | By default, this is the documentation of your REST API from API Gateway. You can provide custom documentation to override this value. | 
| endpoint | stringMinLength: 1MaxLength: 1024 | False | The URL for your REST API. By default, API Gateway uses the default execute API endpoint. You can provide a custom domain to override this value. | 
| operationName | stringMinLength: 1MaxLength: 255 | False | The operation name of the product REST endpoint. | 

### EndpointDisplayContent


Represents the endpoint display content.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| none | [None](#portalproducts-portalproductid-productrestendpointpages-model-none) | False | If your product REST endpoint contains no overrides, the none object is returned. | 
| overrides | [DisplayContentOverrides](#portalproducts-portalproductid-productrestendpointpages-model-displaycontentoverrides) | False | The overrides for endpoint display content. | 

### EndpointDisplayContentResponse


The product REST endpoint page.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| body | stringMinLength: 1MaxLength: 32768 | False | The API documentation. | 
| endpoint | stringMinLength: 1MaxLength: 1024 | True | The URL to invoke your REST API. | 
| operationName | stringMinLength: 1MaxLength: 255 | False | The operation name. | 

### IdentifierParts


The identifier parts of a product REST endpoint.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| method | stringMinLength: 1MaxLength: 20 | True | The method of the product REST endpoint. | 
| path | stringMinLength: 1MaxLength: 4096 | True | The path of the product REST endpoint. | 
| restApiId | stringMinLength: 1MaxLength: 50 | True | The REST API ID of the product REST endpoint. | 
| stage | stringMinLength: 1MaxLength: 128 | True | The stage of the product REST endpoint. | 

### LimitExceededExceptionResponseContent


The response content for limit exceeded exception.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| limitType | string | False | The limit type of the limit exceeded exception response content. | 
| message | string | False | The message of the limit exceeded exception response content. | 

### ListProductRestEndpointPagesResponseContent


Lists the product rest endpoint pages in a portal product.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| items | Array of type [ProductRestEndpointPageSummaryNoBody](#portalproducts-portalproductid-productrestendpointpages-model-productrestendpointpagesummarynobody) | True | The elements from this collection. | 
| nextToken | string | False | The next page of elements from this collection. Not valid for the last element of the collection. | 

### None


The none option.

### NotFoundExceptionResponseContent


The response content for not found exception.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| message | string | False | The message of the not found exception response content. | 
| resourceType | string | False | The resource type of the not found exception response content. | 

### ProductRestEndpointPageSummaryNoBody


A summary of a product REST endpoint page, without providing the page content.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| endpoint | stringMinLength: 1MaxLength: 1024 | True | The endpoint of the product REST endpoint page. | 
| lastModified | stringFormat: date-time | True | The timestamp when the product REST endpoint page was last modified. | 
| operationName | stringMinLength: 1MaxLength: 255 | False | The operation name of the product REST endpoint. | 
| productRestEndpointPageArn | stringMinLength: 20MaxLength: 2048 | True | The ARN of the product REST endpoint page. | 
| productRestEndpointPageId | stringPattern: `^[a-z0-9]+$`MinLength: 10MaxLength: 30 | True | The product REST endpoint page identifier. | 
| restEndpointIdentifier | [RestEndpointIdentifier](#portalproducts-portalproductid-productrestendpointpages-model-restendpointidentifier) | True | The REST endpoint identifier. | 
| status | [Status](#portalproducts-portalproductid-productrestendpointpages-model-status) | True | The status. | 
| statusException | [StatusException](#portalproducts-portalproductid-productrestendpointpages-model-statusexception) | False | The status exception information. | 
| tryItState | [TryItState](#portalproducts-portalproductid-productrestendpointpages-model-tryitstate) | True | The try it state of a product REST endpoint page. | 

### RestEndpointIdentifier


The REST API endpoint identifier.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| identifierParts | [IdentifierParts](#portalproducts-portalproductid-productrestendpointpages-model-identifierparts) | False | The identifier parts of the REST endpoint identifier. | 

### Status


The status.
+ `AVAILABLE`
+ `IN_PROGRESS`
+ `FAILED`

### StatusException


Represents a StatusException.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| exception | stringMinLength: 1MaxLength: 256 | False | The exception. | 
| message | stringMinLength: 1MaxLength: 2048 | False | The error message. | 

### TryItState


Represents the try it state for a product REST endpoint page.
+ `ENABLED`
+ `DISABLED`